"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ypmQ = exports.getRepoUrl = exports.dirNameQ = void 0;
var inquire = require('inquirer');
var ypmQ = {
  type: 'list',
  name: 'ypm',
  message: 'Choose an installer',
  choices: ['yarn', 'npm'],
  "default": 0
};
exports.ypmQ = ypmQ;
var dirNameQ = {
  type: 'input',
  name: 'dirName',
  message: 'Enter a new directory name. To install in current directory, leave blank.'
};
exports.dirNameQ = dirNameQ;
var getRepoUrl = function getRepoUrl(repositoryArg) {
  if (repositoryArg) {
    return Promise.resolve(repositoryArg);
  }
  var question = [{
    type: 'input',
    name: 'repoUrl',
    message: 'Enter your Repo URL (https or ssh)',
    validate: function validate(answer) {
      var httpsPass = answer.match(/^https:\/\/.*.git$/);
      var sshPass = answer.match(/^git@github.com:.*.git$/);
      if (httpsPass || sshPass) {
        return true;
      }
      if (answer && !answer.endsWith('.git')) {
        return 'Repository URL must end with ".git"';
      }
      return 'Please enter a valid repo url';
    }
  }];
  return new Promise(function (resolve, reject) {
    inquire.prompt(question).then(function (answer) {
      if (answer.repoUrl !== '') {
        resolve(answer.repoUrl);
      } else {
        reject(new Error('You did not enter a valid url. exiting...'));
      }
    });
  });
};
exports.getRepoUrl = getRepoUrl;