"use strict";

var fs = require('fs');
var _require = require('kyt-utils/paths')(),
  userPostcssConfigPath = _require.userPostcssConfigPath;
var logger = require('kyt-utils/logger');
var kytPostcssConfig = require('../config/postcss.config');

// We either use the kyt postcss.config.js or we use an
// override from the user.
var postcssConfig = {
  loader: 'postcss-loader'
};
var userHasPostcssConfig = fs.existsSync(userPostcssConfigPath);
if (userHasPostcssConfig) {
  logger.info("Using postcss config: ".concat(userPostcssConfigPath));
  // eslint-disable-next-line global-require,import/no-dynamic-require
  var userPostcssConfig = require(userPostcssConfigPath);
  postcssConfig.options = typeof userPostcssConfig === 'function' ? userPostcssConfig() : userPostcssConfig;
} else {
  postcssConfig.options = kytPostcssConfig;
}
postcssConfig.options.sourceMap = true;
module.exports = postcssConfig;